/**********************************************************************
 *
 * queryaction.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: queryaction.h 206 1999-03-25 03:06:45Z sjboddie $
 *
 *********************************************************************/


#ifndef QUERYACTION_H
#define QUERYACTION_H

#include "gsdlconf.h"
#include "action.h"


class queryaction : public action {
public:
  queryaction ();
  virtual ~queryaction () {}
  
  void configure (const text_t &key, const text_tarray &cfgline);
  bool init (ostream &logout);
  
  text_t get_action_name () {return "q";}
  
  bool check_cgiargs (cgiargsclass &args, ostream &logout);
  void get_cgihead_info (cgiargsclass &args, response_t &response,
			 text_t &response_data, ostream &logout);
  
  void define_internal_macros (displayclass &disp, cgiargsclass &args, 
			       recptproto *collectproto, ostream &logout);
  void define_external_macros (displayclass &disp, cgiargsclass &args, 
			       recptproto *collectproto, ostream &logout);
  
  bool do_action (cgiargsclass &args, recptproto *collectproto,
		  displayclass &disp, outconvertclass &outconvert, 
		  ostream &textout, ostream &logout);
};


#endif
