/**********************************************************************
 *
 * browsetools.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: browsetools.h 213 1999-03-29 02:14:31Z sjboddie $
 *
 *********************************************************************/


#ifndef BROWSETOOLS_H
#define BROWSETOOLS_H

#include "gsdlconf.h"
#include "text_t.h"
#include "cgiargs.h"
#include "display.h"
#include "recptproto.h"

void set_navigation_bar (displayclass &disp, cgiargsclass &args,
			 recptproto *collectproto, const text_t &cname,
			 ostream &logout);
void set_arrow_links (displayclass &disp, cgiargsclass &args, 
		      recptproto *collectproto, const text_t &cname,
		      ostream &logout);
void set_classification_links (displayclass &disp, cgiargsclass &args, 
			       recptproto *collectproto, const text_t &cname,
			       ostream &logout);

void get_hierarchy_toc (cgiargsclass &args, recptproto *collectproto, 
			text_t &toc, ostream &logout);
void get_book_toc (cgiargsclass &args, recptproto *collectproto, 
		   text_t &toc, ostream &logout);
void get_datelist_toc (cgiargsclass &args, recptproto *collectproto, 
		       text_t &toc, ostream &logout);
void get_list_toc (cgiargsclass &args, recptproto *collectproto, 
		   text_t &toc, ostream &logout); 

void get_contracted_toc (cgiargsclass &args, recptproto *collectproto,
			 text_t &return_text, ostream &logout);
void get_expanded_toc (cgiargsclass &args, recptproto *collectproto,
		       text_t &return_text, ostream &logout);
void get_parents_toc (cgiargsclass &args, const text_tarray &parents,
		      int &tabcount, int &colnum, text_t &return_text);
void get_siblings_toc (cgiargsclass &args, const text_tarray &siblings, 
		       int &tabcount, int &colnum, text_t &return_text);


#endif
